; WALL1.LSP
; Routine to draw wall segments (parallel lines) with a given width.
; For use with AutoCAD 2.6 and later.
; Read WALLS.DOC for instructions.
; Copyright 1988 Alacrity


(defun c:WALL1 (/ pt1 pt2 ss ent temp begin ang num)
   (store)
   (setvar "FilletRad" 0)
   (setvar "Blipmode" 0)
   (setq dist (width dist "Width"))
   (initget 1)
   (setq pt1 (getpoint "\nFrom point: "))
   (initget 1)
   (setq pt2 (getpoint pt1 "\nTo point: "))
   (command "LINE" pt1 pt2 "")
   (initget 1)
   (setq ent (entlast) 
         ang (angle pt1 pt2)
         temp (getpoint "\nWhich side? ")
         side (- (angle pt1 temp) ang)
   )
   (if (< side 0.0) (setq side (+ side pi pi)))
   (if (< side pi) (setq side +) (setq side -))
   (command "LINE" (polar pt1 (side ang >90) dist) 
                   (polar pt2 (side ang >90) dist) "")
   (setq begin (list side pt1 (polar pt1 (side ang >90) dist) ent (entlast))
         ss (ssadd (entlast)) 
         pt1 pt2 num 1)
   (while (and 
       (not (initget "Side Width Close"))
       (setq pt2 (getpoint pt1 "\nTo point: "))
       (cond 
            ((equal pt2 "Side")
             (progn
              (ssadd ent ss)
              (setq ent (ssname ss 0))
              (ssdel ent ss)
              (setq pt1 (polar pt1 ang dist) ang (+ ang pi))
              (if (equal side +) (setq side -) (setq side +))
             )
            )
            ((equal pt2 "Width")
             (progn
              (setq dist (width dist "Width"))
              T
             )
            )
            ((equal pt2 "Close")
             (if (> num 1)
               (progn
                (if (equal side (nth 0 begin))
                    (setq pt2 (nth 1 begin) ent (nth 4 begin))
                    (setq pt2 (nth 2 begin) ent (nth 3 begin))
                )
                (command "LINE" pt1 pt2 "")
                (setq ang (side (angle pt1 pt2) >90))
                (command "LINE" (polar pt1 ang dist) (polar pt2 ang dist) "")
                (ssadd (entlast) ss)
                (command "FILLET" ss)
                (ssdel (ssname ss 0) ss)
                (ssadd ent ss)
                (command "FILLET" ss)
               )
               (princ "\nCannot close until two or more segments drawn.")
             )
            )
            (T
             (progn
              (command "LINE" pt1 pt2 "")
              (setq ent (entlast))
              (setq ang (side (angle pt1 pt2) >90))
              (command "LINE" (polar pt1 ang dist) (polar pt2 ang dist) "")
              (ssadd (entlast) ss)
              (command "FILLET" ss)
              (ssdel (ssname ss 0) ss)
              (setq pt1 pt2 num (1+ num))
             )
            )
       )
      ) 
   )
   (restore)
)
